.test-analyzer:
  image: docker:stable-git
  variables:
    SSL_SERVER: registry.gitlab.com/gitlab-org/security-products/tests/custom-ca-ssl-server:latest
    TARGET: all
    RUN_CMD: 1
    SEARCH_CMD: 1
    ANALYZE_CMD: 1
    CONVERT_CMD: 1
  services:
    - docker:stable-dind
  script:
    - docker pull $SSL_SERVER
    - docker network create ssl-test
    - docker run -d --name ssl-test --net ssl-test $SSL_SERVER
    - docker cp ssl-test:ca.crt ca.crt
    - docker build --build-arg BASE_IMAGE=$BASE_IMAGE -t test .
    - |
      run_test() {
        docker run --rm --net=ssl-test -e ADDITIONAL_CA_CERT_BUNDLE="$(cat ca.crt)" test /test.sh $@
      }
    - if [ "$RUN_CMD" -eq 1 ]; then run_test run; else echo skipping run; fi
    - if [ "$SEARCH_CMD" -eq 1 ]; then run_test search /tmp; else echo skipping search; fi
    - if [ "$ANALYZE_CMD" -eq 1 ]; then run_test analyze /tmp; else echo skipping analyze; fi
    - if [ "$CONVERT_CMD" -eq 1 ]; then run_test convert /tmp; else echo skipping convert; fi
  rules:
    - if: '$TARGET == "all"'
      when: always
    - if: '$TARGET == $CI_JOB_NAME'
      when: always
    - when: never

bandit:
  extends: .test-analyzer
  variables:
    BASE_IMAGE: registry.gitlab.com/gitlab-org/security-products/analyzers/bandit:latest

brakeman:
  extends: .test-analyzer
  variables:
    BASE_IMAGE: registry.gitlab.com/gitlab-org/security-products/analyzers/brakeman:latest

bundler-audit:
  extends: .test-analyzer
  variables:
    BASE_IMAGE: registry.gitlab.com/gitlab-org/security-products/analyzers/bundler-audit:latest

eslint:
  extends: .test-analyzer
  variables:
    BASE_IMAGE: registry.gitlab.com/gitlab-org/security-products/analyzers/eslint:latest

flawfinder:
  extends: .test-analyzer
  variables:
    BASE_IMAGE: registry.gitlab.com/gitlab-org/security-products/analyzers/flawfinder:latest

gemnasium-maven:
  extends: .test-analyzer
  variables:
    BASE_IMAGE: registry.gitlab.com/gitlab-org/security-products/analyzers/gemnasium-maven:latest
    SEARCH_CMD: 0
    ANALYZE_CMD: 0
    CONVERT_CMD: 0

gemnasium-python:
  extends: .test-analyzer
  variables:
    BASE_IMAGE: registry.gitlab.com/gitlab-org/security-products/analyzers/gemnasium-python:latest
    SEARCH_CMD: 0
    ANALYZE_CMD: 0
    CONVERT_CMD: 0

gemnasium:
  extends: .test-analyzer
  variables:
    BASE_IMAGE: registry.gitlab.com/gitlab-org/security-products/analyzers/gemnasium:latest
    SEARCH_CMD: 0
    ANALYZE_CMD: 0
    CONVERT_CMD: 0

gosec:
  extends: .test-analyzer
  variables:
    BASE_IMAGE: registry.gitlab.com/gitlab-org/security-products/analyzers/gosec:latest

kics:
  extends: .test-analyzer
  variables:
    BASE_IMAGE: registry.gitlab.com/gitlab-org/security-products/analyzers/kics:latest

klar:
  extends: .test-analyzer
  variables:
    BASE_IMAGE: registry.gitlab.com/gitlab-org/security-products/analyzers/klar:latest
    SEARCH_CMD: 0
    CONVERT_CMD: 0

kubesec:
  extends: .test-analyzer
  variables:
    BASE_IMAGE: registry.gitlab.com/gitlab-org/security-products/analyzers/kubesec:latest

mobsf:
  extends: .test-analyzer
  variables:
    BASE_IMAGE: registry.gitlab.com/gitlab-org/security-products/analyzers/mobsf:latest

nodejs-scan:
  extends: .test-analyzer
  variables:
    BASE_IMAGE: registry.gitlab.com/gitlab-org/security-products/analyzers/nodejs-scan:latest
    ANALYZE_CMD: 0
    CONVERT_CMD: 0

phpcs-security-audit:
  extends: .test-analyzer
  variables:
    BASE_IMAGE: registry.gitlab.com/gitlab-org/security-products/analyzers/phpcs-security-audit:latest

pmd-apex:
  extends: .test-analyzer
  variables:
    BASE_IMAGE: registry.gitlab.com/gitlab-org/security-products/analyzers/pmd-apex:latest

retire.js:
  extends: .test-analyzer
  variables:
    BASE_IMAGE: registry.gitlab.com/gitlab-org/security-products/analyzers/retire.js:latest

secrets:
  extends: .test-analyzer
  variables:
    BASE_IMAGE: registry.gitlab.com/gitlab-org/security-products/analyzers/secrets:latest
    SEARCH_CMD: 0
    ANALYZE_CMD: 0
    CONVERT_CMD: 0

security-code-scan:
  extends: .test-analyzer
  variables:
    BASE_IMAGE: registry.gitlab.com/gitlab-org/security-products/analyzers/security-code-scan:latest

semgrep:
  extends: .test-analyzer
  variables:
    BASE_IMAGE: registry.gitlab.com/gitlab-org/security-products/analyzers/semgrep:latest

sobelow:
  extends: .test-analyzer
  variables:
    BASE_IMAGE: registry.gitlab.com/gitlab-org/security-products/analyzers/sobelow:latest

spotbugs:
  extends: .test-analyzer
  variables:
    BASE_IMAGE: registry.gitlab.com/gitlab-org/security-products/analyzers/spotbugs:latest

tslint:
  extends: .test-analyzer
  variables:
    BASE_IMAGE: registry.gitlab.com/gitlab-org/security-products/analyzers/tslint:latest
